{******* Calculs sur un vecteur ***********************************************}
{* Remarquez la correspondance entre le nom de l'unit et le nom du fichier   *}
{******************************************************************************}
unit UVecteur;

interface

CONST
     {code d'erreur  renvoyer en cas d'erreur sur un calcul}
     ERR_CALC_VALUE_VECTEUR : double = -99999;

TYPE
    {type de donnes vecteur}
    TVecteur = array of Double;

    //allocation de la mmoire
    procedure initialiser(n: integer; var vec: TVecteur);

    {*************************************************************}
    //!\ ce qui est nouveau par rapport  la correction au tableau
    //!\ c'est que la taille du tableau est rcupre par "Length"
    //!\ il n'est plus pass en paramtre
    {**************************************************************}

    //saisie des donnes
    procedure saisie(var vec: TVecteur);
    //dsallocation de la mmoire
    procedure desallouer(var vec: TVecteur);
    //affichage
    procedure affichage(var vec: TVecteur);

    //calcul de la moyenne
    function  moyenne(var vec: TVecteur): double;
    //calcul de l'cart-type
    function  ecarttype(var vec: TVecteur): double;
    //calcul de la mdiane
    function  mediane(var vec: TVecteur): double;

implementation

//allocation de la mmoire
procedure initialiser(n: integer; var vec: TVecteur);
begin
 SetLength(vec,n);
end;

//saisie des donnes
procedure saisie(var vec: TVecteur);
var i: integer;
begin
 //!\ Length(Vec) renvoie la taille (le nombre de cases) du tableau
 for i:= 0 to Length(vec)-1 do
  begin
   write('Element n-',i,' = ');
   readln(vec[i]);
  end;
end;

//dsallocation de la mmoire
procedure desallouer(var vec: Tvecteur);
begin
 SetLength(vec,0);
end;

//affichage
procedure affichage(var vec: TVecteur);
var i,n: integer;
begin
 n:= Length(vec);
 writeln('-- DEBUT -- Affichage des valeurs --');
 for i:= 0 to n-1 do
  writeln('Vec[',i,']=',Vec[i]);
 writeln('--  FIN  -- Affichage des valeurs --');
end;


//calcul de la moyenne
function  moyenne(var vec: TVecteur): double;
var i,n: integer;
    somme: double;
begin
 n:= Length(vec);
 if (n>0)
  then
   begin
    somme:= 0.0;
    for i:= 0 to n-1 do
     somme:= somme+vec[i];
    result:= somme/(1.0*n);
   end
  else result:= ERR_CALC_VALUE_VECTEUR;
end;

//calcul de l'cart-type
function  ecarttype(var vec: TVecteur): double;
var i,n: integer;
    somme,moy: double;
begin
 n:= Length(vec);
 if (n>0)
  then
   begin
    moy:= moyenne(vec);

    somme:= 0.0;
    for i:= 0 to n-1 do
     somme:= somme+SQR(vec[i]-moy);//SQR est le carr
    result:= SQRT(somme/(1.0*n));//SQRT est la racine carre
   end
  else result:= ERR_CALC_VALUE_VECTEUR;
end;

//pour pouvoir calculer la mdiane, on a besoin de la fonction de TRI
//!\ elle est prive, i.e. visible uniquement dans l'unit
procedure trier(var vec: TVecteur);
var i,j,jMin,n: integer;
    curMin: double;
begin
 n:= Length(vec);
 if (n>0)
  then
   begin
    //n-2 car trouver les n-1 premiers permet de trier tout le tableau (les n valeurs)
    for i:= 0 to n-2 do
     begin
      jMin:= i;
      curMin:= vec[i];
      //vrifier s'il y a une valeur plus petite dans le reste du tableau
      //et rcuprer son indice
      for j:= i+1 to n-1 do
       begin
        if (vec[j]<curMin)
         then
          begin
           curMin:= vec[j];
           jMin:= j;
          end;
       end;
      //procder  l'change
      vec[jMin]:= vec[i];
      vec[i]:= curMin;
     end;
   end;
end;

//calcul de la mdiane
function  mediane(var vec: TVecteur): double;
var n: integer;
begin
 n:= Length(vec);
 if (n>0)
  then
   begin
    trier(vec);
    if ((n mod 2) <>0)
     then result:= vec[n div 2]
     else result:= 0.5*(vec[(n div 2)-1]+vec[n div 2]);
   end
  else result:= ERR_CALC_VALUE_VECTEUR;
end;

end.
